                 (* +---------------------------------------------+
                    |  Utilitaires pour le TP de dfragmentation  |
                    +---------------------------------------------+ *)

(*--------------------------------------------------- entres dans un rpertoire *)
type t_entre = D (* dir      *)
              | F (* fichier  *)
              | S (* supprim *)
;;

type entre = {
  typ   : t_entre; (* type de l'entre             *)
  nom   : string;   (* nom du fichier ou rpertoire *)
  dbut : int       (* numro du premier secteur    *)
};;

(*---------------------------------------------------- modlisatiopn d'un disque *)
type secteur = 
  | FAT  of int vect
  | DIR  of entre vect
  | DATA of string * int * string  (* nom, numro d'ordre, texte *)
;;

type disque = {

  ns : int; 	  (* nombre total de secteurs     *)
  cf : int; 	  (* capacit d'un bloc de FAT    *)
  nf : int; 	  (* n. secteurs FAT, de 0  nf-1 *)
  cd : int; 	  (* capacit d'un secteur DIR    *)
  ms : int;       (* maximum d'un accs en bloc   *)

  lit_secteur   : int -> secteur;
  crit_secteur : int -> secteur -> unit;
  lit_secteurs  : (int*int) -> secteur list;
  crit_secteurs: int -> secteur list -> unit;

  mutable necr  : int;  (* compteur critures, peut tre remis  zro *)
  mutable nlect : int;  (* compteur lectures,  idem                   *)
};;

(*------------------------------------------------- pour la fonction d'affichage *)
type champ = 
  | NOM       (* affiche la partie nom d'un secteur DATA     *)
  | NUMERO    (* affiche le numro d'ordre d'un secteur DATA *)
  | TEXTE     (* affiche la partie texte d'un secteur DATA   *)
  | SECTEUR   (* affiche le numro d'un secteur DATA         *)
;;

(*------------------------------------------------------ fonctions de conversion *)
value fat_of_secteur  : secteur -> int vect;;
value dir_of_secteur  : secteur -> entre vect;;
value data_of_secteur : secteur -> string * int * string;;

(*-------------------------------------------------------------- accs au disque *)
value read_fat  : disque -> int vect;;            (* lit la totalit de la FAT   *)
value write_fat : disque * int vect -> unit;;     (* crit la totalit de la FAT *)
(* Attention : la longueur du vecteur est un multiple du champ disque.cf, les    *)
(* entres surnumraires sont ignores.                                          *)

value init_disque : (int*int) -> disque;; (* cre un disque vierge ayant [n] secteurs  *)

value random_fic : disque * int * int * int * int -> unit;;
value random_rep : disque * int -> unit;;
(* random_fic(disque,n,cr,dl,taille) cre si possible [cr] fichiers de taille    *)
(* alatoire  entre 1 et [taille], puis en dtruit [dl] et rpte ceci [n] fois  *)
(* de suite.                                                                     *)
(* random_rep(disque,n) cre [n] sous-rpertoires disposs alatoirement dans    *)
(* l'arborescence.                                                               *)

(*----------------------------------------------------------------------- divers *)
value affiche    : disque * champ -> unit;;  (* affichage selon le champ indiqu *)
value vrifie    : disque -> unit;;          (* vrifie la cohrence du disque   *)
value enregistre : disque * string -> unit;; (* enregistrement sur disque rel   *)
value relit      : string -> disque;;        (* relecture d'un enregistrement    *)
value compare    : disque * disque -> unit;; (* compare deux disques logiquement *)

(*-------------------------------------------------------------------------------*)

