/* +------------------------------------------------------------------------+
   |                                                                        |
   |                                                                        |
   |                          Calcul de a^(1/k) en grande prcision         |
   |                                                                        |
   |                                                                        |
   +------------------------------------------------------------------------+ */


#include <math.h>
#include <stdio.h>
#include <gmp.h>


void itere(unsigned a, unsigned k, mpf_t x, mpf_t y) {
int i;

  /* pas de subtilits, trois mots de trop devraient suffire ... */
  mpf_set_prec(y, 2*mpf_get_prec(x) + 2*mp_bits_per_limb);
  
  /* calcul de x^k */
  for (i=2; i <= k; i <<= 1);
  mpf_set(y,x);
  for (i >>= 2; i > 0; i >>= 1) {
    mpf_mul(y,y,y);
    if (i & k) mpf_mul(y,x,y);
  }

  /* calcul de x + x(a-x^k)/(ka) */
  mpf_ui_sub(y,a,y);
  mpf_mul(y,x,y);
  mpf_div_ui(y,y,k*a);
  mpf_add(y,x,y);

  /* tronque le rsultat */
  mpf_set_prec(y,mpf_get_prec(y) - 3*mp_bits_per_limb);
}
  
int main(int argc, char ** argv) {
  mpf_t x[2];
  unsigned a,d,k;
  int i;

  a = atoi(argv[1]);
  k = atoi(argv[2]);
  d = 1 + 4*atoi(argv[3])/log10(2);

  mpf_init2(x[0], 2*mp_bits_per_limb);
  mpf_init(x[1]);

  /* calcul initial de a^(1/k) */
  mpf_set_d(x[0], pow((double) a, 1/((double) k)));

  /* itrations */
  for (i=0; mpf_get_prec(x[i]) < d; i=1-i) itere(a,k,x[i],x[1-i]);

  /* affichage : dsactiv, le temps de conversion est en O(n^2) ... */
  mpf_out_str(NULL,10,0,x[i]);
  putchar('\n');
  /* */
  return(0);

}



