(*****************************************************************************
 *                                                                           *
 *                         Fonctions de mmorisation                         *
 *                                                                           *
 * M. Quercia, le 13/10/96                                                   *
 *****************************************************************************)



                   (* +----------------------------------+
                      |  Mmorisation par liste chaine  |
                      +----------------------------------+ *)


let mmoire__liste() =
  let memoire = ref([]) in
  let djavu(x) = try list__assoc x !memoire with Not_found -> -1
  and note x y  = memoire := (x,y) :: !memoire
  and raz()     = memoire := []
  and taille()  = list_length(!memoire)
  in (djavu,note,raz,taille)
;;


                  (* +-------------------------------------+
                     |  Mmorisation par table de hachage  |
                     +-------------------------------------+ *)


let mmoire__table() =
  let memoire = hashtbl__new(17) in
  let djavu(x) = try hashtbl__find memoire x with Not_found -> -1
  and note x y  = hashtbl__add memoire x y
  and raz()     = hashtbl__clear memoire
  and taille()  = let n = ref 0 in
                  let compte _ _ = incr n in
                  hashtbl__do_table compte memoire;
                  !n 
  in (djavu,note,raz,taille)
;;


              (* +--------------------------------------------+
                 |  Mmorisation par arbre binaire quilibr  |
                 +--------------------------------------------+ *)

let mmoire__arbre() =
  let memoire = ref(map__empty eq__compare) in
  let djavu(x) = try map__find x !memoire with Not_found -> -1
  and note x y  = memoire := map__add x y !memoire
  and raz()     = memoire := map__empty eq__compare
  and taille()  = let n = ref 0 in
                  let compte _ _ = incr n in
                  map__iter compte !memoire;
                  !n 
  in (djavu,note,raz,taille)
;;
