(*****************************************************************************
 *                                                                           *
 *                         Fonctions de mmorisation                         *
 *                                                                           *
 * M. Quercia, le 19/04/96                                                   *
 *****************************************************************************)



                   (* +----------------------------------+
                      |  Mmorisation par liste chaine  |
                      +----------------------------------+ *)


let mmoire__liste() =
  let memoire = ref([]) in
  let djavu(x) = try List.assoc x !memoire with Not_found -> -1
  and note x y  = memoire := (x,y) :: !memoire
  and raz()     = memoire := []
  and taille()  = List.length(!memoire)
  in (djavu,note,raz,taille)
;;


                  (* +-------------------------------------+
                     |  Mmorisation par table de hachage  |
                     +-------------------------------------+ *)


let mmoire__table() =
  let memoire = Hashtbl.create(17) in
  let djavu(x) = try Hashtbl.find memoire x with Not_found -> -1
  and note x y  = Hashtbl.add memoire x y
  and raz()     = Hashtbl.clear memoire
  and taille()  = let n = ref 0 in
                  let compte _ _ = incr n in
                  Hashtbl.iter compte memoire;
                  !n 
  in (djavu,note,raz,taille)
;;


              (* +--------------------------------------------+
                 |  Mmorisation par arbre binaire quilibr  |
                 +--------------------------------------------+ *)

let mmoire__arbre() =
  let memoire = ref(Mappe.empty compare) in
  let djavu(x) = try Mappe.find x !memoire with Not_found -> -1
  and note x y  = memoire := Mappe.add x y !memoire
  and raz()     = memoire := Mappe.empty compare
  and taille()  = let n = ref 0 in
                  let compte _ _ = incr n in
                  Mappe.iter compte !memoire;
                  !n 
  in (djavu,note,raz,taille)
;;
