(*****************************************************************************
 *                                                                           *
 *                               Jeu du taquin                               *
 *                                                                           *
 * M. Quercia, le 19/04/98                                                   *
 *****************************************************************************)

(* copie de matrices *)
let copy_matrix(mat) =
  let n = Array.length(mat)    in
  let mat' = Array.create n [||] in
  for i=0 to n-1 do mat'.(i) <- Array.copy mat.(i) done;
  mat'
;;


(* affichage d'une matrice *)
let print_int_matrix(t) =
  let n = Array.length(t) and p = Array.length(t.(0)) in
  for i=0 to n-1 do
    print_newline();
    for j=0 to p-1 do
      let s = ref(string_of_int(t.(i).(j))) in
      while String.length(!s) < 4 do s := " " ^ !s done;
      print_string(!s)
    done
  done;
  print_newline()
;;

(* animation graphique *)
open Taquintk;;

(*
 * random_chemin(succ,noeud,n)
 *
 * Effectue n mouvements alatoires sur "noeud" et renvoie le
 * chemin obtenu.
 *)

let random_chemin(succ,noeud,n) =

  (* tire un lment au hasard dans "liste" *)
  let rec random_elt(liste) =
    let k = Random.int(List.length liste) in
    List.nth liste k
  in

  (* diffrence de deux listes *)
  let rec list_substract l l' = match l with
  | [] -> []
  | a::suite when List.mem a l' -> list_substract suite l'
  | a::suite -> a :: list_substract suite l'
  in

  (* rallonge alatoirement "dbut" de "n" tapes *)
  let rec prolonge(dbut,n) =
    if n=0 then dbut
    else let l = list_substract (succ(List.hd dbut)) dbut in
    (* "l" = liste des successeurs non encore visits *)
    match l with
    | []  -> failwith "impasse"
    | [x] -> prolonge(x::dbut,n-1)
    | _   -> (* s'il y a au moins deux successeurs possibles, tire  *)
             (* au hasard celui  prendre. En cas d'chec, ressaye *)
             (* au plus 2 fois                                      *)
             try prolonge(random_elt(l)::dbut,n-1)
             with Failure "impasse" ->
             try prolonge(random_elt(l)::dbut,n-1)
             with Failure "impasse" ->
             prolonge(random_elt(l)::dbut,n-1)
  
  in prolonge([noeud],n)
;;

