{+----------------------------------------------------------------------------+
 |                                                                            |
 |                             Jeu du taquin                                  |
 |                                                                            |
 +----------------------------------------------------------------------------+}
{ M.Quercia, le 26/04/98 }

{$i graphe.p}

const tsize = 5; { taille des taquins }
      ts2   = tsize*tsize-1;

type ptaquin = ^taquin;
     tech    =  array[0..ts2] of integer;
     taquin  = record
		  pos : tech;    { position des pices }
		  ech : tech;    { chiquier           }
		  nxt : ptaquin; { lien avant pour destruction }
		  pre : ptaquin; { lien arrire pour destr.    }
	       end;   


var tliste: ptaquin; { liste des taquins en mmoire }


                         {+--------------------------+
                          |  Affichage d'un taquin   |
                          +--------------------------+}

procedure affiche(var x);
var i : integer;
begin
   for i:=0 to ts2 do begin
      write(taquin(x).ech[i]:3);
      if i mod tsize = tsize-1 then writeln;
   end;
   writeln;
end; { affiche }
   
                         {+---------------------------+
                          |  Successeurs d'un taquin  |
                          +---------------------------+}

function tsucc(var x): pliste;
var q : pliste; { liste rsultat }
    u: integer; { position actuelle du trou }

  procedure insere(t: integer); { cre un taquin avec le trou en t }
  var p	: ptaquin;
     r	: pliste;
  begin
     new(p);
     p^ := taquin(x);
     p^.ech[t] := 0;
     p^.pos[0] := t;
     p^.ech[u] := taquin(x).ech[t];
     p^.pos[taquin(x).ech[t]] := u;
     p^.pre := nil;
     p^.nxt := tliste;
     if tliste <> nil then tliste^.pre := p;
     tliste := p;
     new(r);
     r^.x := p;
     r^.suiv := q;
     q := r;
  end; { insere }

begin
   u := taquin(x).pos[0];
   q := nil;
   if u mod tsize > 0       then insere(u-1);
   if u mod tsize < tsize-1 then insere(u+1);
   if u >= tsize            then insere(u-tsize);
   if u <= ts2-tsize        then insere(u+tsize);
   tsucc := q;
end; { tsucc }

                            {+---------------------+
                             |  limine un taquin  |
                             +---------------------+}

procedure tdisp(p : pointer);
var q,r: ptaquin;
begin
   q := ptaquin(p)^.nxt;
   r := ptaquin(p)^.pre;
   if q <> nil then q^.pre := r;
   if r <> nil then r^.pre := q else tliste := q;
   dispose(ptaquin(p));
end; { tdisp }
   
     
                         {+---------------------------+
                          |  distances entre taquins  |
                          +---------------------------+}


function pions_mal_places(var x,y): integer;
var i,d : integer;
begin
   d := 0;
   for i:=1 to ts2 do if taquin(x).pos[i] <> taquin(y).pos[i] then d := d+1;
   pions_mal_places := d;
end; { pions_mal_places }


function manhattan(var x,y): integer;
var i,d,ux,vx,uy,vy : integer;
begin
   d := 0;
   for i:=1 to ts2 do begin
      ux := taquin(x).pos[i] mod tsize;
      vx := taquin(x).pos[i] div tsize;
      uy := taquin(y).pos[i] mod tsize;
      vy := taquin(y).pos[i] div tsize;
      d := d + abs(ux-uy) + abs(vx-vy);
   end;
   manhattan := d;
end; { manhattan }
   

                 {+------------------------------------------+
                  |  Cre un taquin  partir d'un chiquier  |
                  +------------------------------------------+}

procedure cree_taquin(var e : tech; var t:taquin);
var i : integer;
begin with t do begin
   ech := e;
   for i:=0 to ts2 do pos[e[i]] := i;
   nxt := nil;
   pre := nil;
end end;


   
                          {+------------------------+
                           |  Rsolution gnrique  |
                           +------------------------+}


procedure resoud(var depart,but	: taquin;
		     pmax	: integer;
		     mem	: string;
		     strat	: string;
		 var p  	: pliste;
		 var taille	: integer);
var g1,g2 : graphe;
begin
   
   if mem = "liste" then begin
      memoire_a_liste(g1.m);
      memoire_a_liste(g2.m);
   end
   else begin
      memoire_a_arbre(g1.m);
      memoire_a_arbre(g2.m);
   end;
   g1.lg   := ts2 * size(integer);
   g2.lg   := ts2 * size(integer);
   if strat = "place" then begin
      g1.d := pions_mal_places;
      g2.d := pions_mal_places;
   end
   else begin
      g1.d := manhattan;
      g2.d := manhattan;
   end;
   g1.succ := tsucc;
   g2.succ := tsucc;
   g1.disp := tdisp;
   g2.disp := tdisp;

   if (strat <> "place") and (strat <> "manh") then begin
      g1.m.note(g1.m.donnees,depart,g1.lg,pmax);
      g2.m.note(g2.m.donnees,but,   g2.lg,pmax);
   end;

        if strat = "prof"  then p := pprof(g1, depart, but, pmax)
   else if strat = "larg"  then p := plarg(g1, depart, but)
   else if strat = "larg2" then p := plarg2(g1,g2, depart, but)
   else p := pheur(g1, depart, but);

   taille := g1.m.taille(g1.m.donnees) + g2.m.taille(g2.m.donnees);

end; { resoud }
   

const but    : tech = (  1,  2,  3,  4,  5,
		         6,  7,  8,  9, 10,
		        11, 12, 13, 14, 15,
		        16, 17, 18, 19, 20,
		        21, 22, 23, 24,  0);

(*
const source : tech = (  1,  2,  3,  4,  5,
		         6,  7,  8,  9, 10,
		        11, 12, 13, 14, 15,
 		        17, 18, 19, 20,  0,
		        16, 21, 22, 23, 24);
*)
var tsource, tbut : taquin;
   g		  : graphe;
   p		  : pliste;
   taille,pmax	  : integer;
begin

   if paramcount < 4 then begin
      writeln('syntaxe : taquin (liste|arbre) (prof|larg|larg2|place|manh) pmax seed [print]');
      halt;
   end;
   
   cree_taquin(but, tbut);
   memoire_a_arbre(g.m);
   g.lg    := ts2 * size(integer);
   g.d     := pions_mal_places;
   g.succ  := tsucc;
   g.disp  := tdisp;
   g.m.note(g.m.donnees,tbut,g.lg,1);
   
   pmax    := atoi(paramstr(3));
   srand(atoi(paramstr(4)));
   tsource := ptaquin(random_noeud(g, tbut, pmax))^;
   writeln('but :');    affiche(tbut);
   writeln('source :'); affiche(tsource);
   resoud(tsource, tbut, 9, paramstr(1), paramstr(2), p, taille);

   if paramcount >= 5 then
      while p <> nil do begin affiche(p^.x^); p := p^.suiv; end;
   writeln('taille = ',taille:0);

end.
   




