{+----------------------------------------------------------------------------+
 |                                                                            |
 |                       Tauto.p : Dtection de tautologies                   |
 |                                                                            |
 +----------------------------------------------------------------------------+}
{ M.Quercia, le 12/04/98 }

{$i tp-bool.p}

                {+---------------------------------------------+
                 |  Oprations boolennes avec simplification  |
                 +---------------------------------------------+}


function simplifie_et(x,y : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then
      if x^.c then begin
	 dispose(x);
	 simplifie_et := y;
      end
      else begin
	 dispose(y);
	 simplifie_et := x;
      end
   else if y^.nature = Constante then
      if y^.c then begin
	 dispose(y);
	 simplifie_et := x;
      end
      else begin
	 dispose(x);
	 simplifie_et := y;
      end
   else begin
      new(p);
      p^.nature := Bin;
      p^.op := Et;
      p^.g := x;
      p^.d := y;
      simplifie_et := p;
   end;
end; { simplifie_et }
   
function simplifie_ou(x,y : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then
      if x^.c then begin
	 dispose(y);
	 simplifie_ou := x;
      end
      else begin
	 dispose(x);
	 simplifie_ou := y;
      end
   else if y^.nature = Constante then
      if y^.c then begin
	 dispose(x);
	 simplifie_ou := y;
      end
      else begin
	 dispose(y);
	 simplifie_ou := x;
      end
   else begin
      new(p);
      p^.nature := Bin;
      p^.op := Ou;
      p^.g := x;
      p^.d := y;
      simplifie_ou := p;
   end;
end; { simplifie_ou }

function simplifie_non(x : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then begin
      x^.c := not(x^.c);
      simplifie_non := x;
   end
   else if x^.nature = Non then begin
      p := x^.n;
      dispose(x);
      simplifie_non := p;
   end
   else begin
      new(p);
      p^.nature := Non;
      p^.n := x;
      simplifie_non := p;
   end;
end; { simplifie_non }

function simplifie_oubien(x,y : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then
      if x^.c then begin
	 dispose(x);
	 simplifie_oubien := simplifie_non(y);
      end
      else begin
	 dispose(x);
	 simplifie_oubien := y;
      end
   else if y^.nature = Constante then
      if y^.c then begin
	 dispose(y);
	 simplifie_oubien := simplifie_non(x);
      end
      else begin
	 dispose(y);
	 simplifie_oubien := x;
      end
   else begin
	 new(p);
	 p^.nature := Bin;
	 p^.op := Oubien;
	 p^.g := x;
	 p^.d := y;
	 simplifie_oubien := p;
   end;
end; { simplifie_oubien }
   
function simplifie_equiv(x,y : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then
      if x^.c then begin
	 dispose(x);
	 simplifie_equiv := y;
      end
      else begin
	 dispose(x);
	 simplifie_equiv := simplifie_non(y);
      end
   else if y^.nature = Constante then
      if y^.c then begin
	 dispose(y);
	 simplifie_equiv := x;
      end
      else begin
	 dispose(y);
	 simplifie_equiv := simplifie_non(x);
      end
   else begin
	 new(p);
	 p^.nature := Bin;
	 p^.op := Equiv;
	 p^.g := x;
	 p^.d := y;
	 simplifie_equiv := p;
   end;
end; { simplifie_equiv }
	 
function simplifie_impl(x,y : pformule) : pformule;
var p : pformule;
begin
   if x^.nature = Constante then
      if x^.c then begin
	 dispose(x);
	 simplifie_impl := y;
      end
      else begin
	 dispose(y);
	 x^.c := true;
	 simplifie_impl := x;
      end
   else if y^.nature = Constante then
      if y^.c then begin
	 dispose(x);
	 simplifie_impl := y;
      end
      else begin
	 dispose(y);
	 simplifie_impl := simplifie_non(x);
      end
   else begin
      new(p);
      p^.nature := Bin;
      p^.op := Impl;
      p^.g := x;
      p^.d := y;
      simplifie_impl := p;
   end;
end; { simplifie_impl }


                {+--------------------------------------------+
                 |  Evaluation partielle avec simplification  |
                 +--------------------------------------------+}

{ Remplace la variable "v" par "b" et simplifie le rsultat }
function eval_et_simplifie(f : pformule; var v : string; b : boolean): pformule;
var p : pformule;
begin
   case f^.nature of
     
     Constante : begin
		    new(p);
		    p^ := f^;
		    eval_et_simplifie := p;
		 end;

     Variable  : begin
		    new(p);
		    if v = f^.v then begin
		       p^.nature := Constante;
		       p^.c := b;
		    end
		    else p^ := f^;
		    eval_et_simplifie := p;
		 end;

     Non : eval_et_simplifie := simplifie_non(eval_et_simplifie(f^.n,v,b));
     Bin : case f^.op of
	     Et	    : eval_et_simplifie := simplifie_et(
	                                 eval_et_simplifie(f^.g,v,b),
              	                         eval_et_simplifie(f^.d,v,b));
	     Ou	    : eval_et_simplifie := simplifie_ou(
	                                 eval_et_simplifie(f^.g,v,b),
              	                         eval_et_simplifie(f^.d,v,b));
	     Oubien : eval_et_simplifie := simplifie_oubien(
	                                 eval_et_simplifie(f^.g,v,b),
              	                         eval_et_simplifie(f^.d,v,b));
	     Equiv  : eval_et_simplifie := simplifie_equiv(
	                                 eval_et_simplifie(f^.g,v,b),
              	                         eval_et_simplifie(f^.d,v,b));
	     Impl   : eval_et_simplifie := simplifie_impl(
	                                 eval_et_simplifie(f^.g,v,b),
              	                         eval_et_simplifie(f^.d,v,b));
	   end; { case }
   end; { case }
end;


                          {+-------------------------+
                           |  Dsalloue une formule  |
                           +-------------------------+}

procedure detruit_formule(f : pformule);
begin
   case f^.nature of
     Constante : ;
     Variable  : ;
     Non       : detruit_formule(f^.n);
     Bin       : begin detruit_formule(f^.g); detruit_formule(f^.d) end;
   end; { case }
   dispose(f);
end;


               {+-----------------------------------------------+
                |  Dresse la liste des variables d'une formule  |
                +-----------------------------------------------+}

type pvariable = ^cvariable;
   cvariable   =  record
		     nom  : string;
		     val  : boolean;
		     suiv : pvariable;
		  end;

function liste_variables(f :  pformule) : pvariable;
var p : pvariable;
   
  procedure insere(var nom : string);
  var q	: ^pvariable;
  begin
     q := @p;
     while (q^ <> nil) and (q^^.nom <> nom) do q := @(q^^.suiv);
     if q^ = nil then begin
	new(q^);
	q^^.nom := nom;
	q^^.suiv := nil;
     end;
  end; { insere }

  procedure parcours(f : pformule);
  begin case f^.nature of
    Constante : ;
    Variable  : insere(f^.v);
    Non	      : parcours(f^.n);
    Bin	      : begin parcours(f^.g); parcours(f^.d) end;
  end end;

begin
   p := nil;
   parcours(f);
   liste_variables := p;
end;


                    {+------------------------------------+
                     |  dsalloue une liste de variables  |
                     +------------------------------------+}

procedure detruit_liste(l : pvariable);
var p : pvariable;
begin
   while l <> nil do begin
      p := l;
      l := l^.suiv;
      dispose(p);
   end;
end; { detruit_liste }


                     {+----------------------------------+
                      |  Imprime une liste de variables  |
                      +----------------------------------+}


procedure imprime_liste(p : pvariable);
begin
   while p <> nil do with p^ do begin
      write(nom,'=');
      if val then write('vrai ') else write('faux ');
      p := suiv;
   end;
   writeln;
end; { imprime_liste }


                        {+----------------------------+
                         |  cout = 2^longueur(liste)  |
                         +----------------------------+}

function cout(l	: pvariable) : real;
var c :  real;
begin
   c := 1.0;
   while l <> nil do begin
      c := 2.0*c;
      l := l^.suiv;
   end;
   cout := c;
end; { cout }
   

                      {+---------------------------------+
                       |  Algorithme de Davis et Putnam  |
                       +---------------------------------+}


procedure Davis_Putnam(f	 : pformule;      { formule  analyser  }
		       lv	 : pvariable;     { liste des variables }
		       opt	 : boolean;       { rech. optimise ?   }
		       var tauto : boolean;       { tautologie ?        }
		       var lref	 : pvariable);    { cas de rfutation   }

var   vmin : string;     { nom du meilleur pivot }
   g,h	   : pformule;   { formules dduites     }
   lg,lh   : pvariable;  { liste des variables   }
   min	   : real;       { cot du pivot         }
   p	   : pvariable;
   g1,h1   : pformule;
   lg1,lh1 : pvariable;
   m1	   : real;
   
begin
   
   if lv = nil then begin
      tauto := f^.c;
      lref := nil;
   end
   
   else begin

      { cherche le meilleur pivot }
      vmin := lv^.nom;
      g    := eval_et_simplifie(f,vmin,true);  lg := liste_variables(g);
      h    := eval_et_simplifie(f,vmin,false); lh := liste_variables(h);
      min  := cout(lg) + cout(lh);
      p    := lv^.suiv;

      if opt then while p <> nil do begin
	 g1 := eval_et_simplifie(f,p^.nom,true);  lg1 := liste_variables(g1);
	 h1 := eval_et_simplifie(f,p^.nom,false); lh1 := liste_variables(h1);
	 m1 := cout(lg1) + cout(lh1);
	 if m1 < min then begin
	    detruit_formule(g);
	    detruit_formule(h);
	    detruit_liste(lg);
	    detruit_liste(lh);
	    g := g1;
	    h := h1;
	    lg := lg1;
	    lh := lh1;
	    vmin := p^.nom;
	    min := m1;
	 end
	 else begin
	    detruit_formule(g1);
	    detruit_formule(h1);
	    detruit_liste(lg1);
	    detruit_liste(lh1);
	 end;
	 p := p^.suiv;
      end;
      
      { cherche une rfutation }
      Davis_Putnam(g,lg,opt,tauto,lref);
      if not(tauto) then begin
	 new(p);
	 p^.nom  := vmin;
	 p^.val  := true;
	 p^.suiv := lref;
	 lref := p;
      end
      else begin
	 Davis_Putnam(h,lh,opt,tauto,lref);
	 if not(tauto) then begin
	    new(p);
	    p^.nom  := vmin;
	    p^.val  := false;
	    p^.suiv := lref;
	    lref := p;
	 end
      end;
      detruit_formule(g);
      detruit_formule(h);
      detruit_liste(lg);
      detruit_liste(lh);
   end;
end; { Davis_Putnam }
   

                          {+------------------------+
                           |  Recherche exhaustive  |
                           +------------------------+}

procedure exhaustive(  f	 : pformule;      { formule  analyser  }
		       lv	 : pvariable;     { liste des variables }
		       var tauto : boolean);      { tautologie ?        }


  { value une formule }
  function evalue(f : pformule) : boolean;
  var p : pvariable;
  begin with f^ do case nature of
    Constante : evalue := c;
    Variable  : begin
		   p := lv;
		   while p^.nom <> v do p := p^.suiv;
		   evalue := p^.val;
		end;
    Non	    : evalue := not(evalue(n));
    Bin	    : case op of
		  Et     : evalue := evalue(g) and evalue(d);
		  Ou     : evalue := evalue(g) or  evalue(d);
		  Oubien : evalue := evalue(g) <>  evalue(d);
		  Equiv  : evalue := evalue(g) =   evalue(d);
		  Impl   : evalue := evalue(g) <=  evalue(d);
		end; { case }
  end end;
   

  { balaye rcusrivement toutes les distributions de vrit }
  procedure cherche_rec(l : pvariable);
  begin
     if l = nil then tauto := evalue(f)
     else begin
	l^.val := true;
	cherche_rec(l^.suiv);
	if tauto then begin
	   l^.val := false;
	   cherche_rec(l^.suiv);
	end;
     end;
  end; { cherche_rec }


begin
   cherche_rec(lv);
end;


                                  {+---------+
                                   |  Essai  |
                                   +---------+}


var s	    : string;
   f,g	    : pformule;
   n,h,seed : integer;
   v	    : pvariable;
   tauto    : boolean;
   lref	    : pvariable;
   opt	    : boolean;
begin
   
   write('formule : '); readln(s);
   if s[1] = '?' then begin
      write('hasard, nombre de variables : '); readln(n);
      write('        hauteur maximum     : '); readln(h);
      write('        graine alatoire    : '); readln(seed);
      srand(seed);
      f := f_alea(n,h);
      if h <= 5 then imprime_formule(f^);
      g := copie_formule(f);
      f := simplifie_impl(f,g);
   end
   else f := evalue(s);

   v := liste_variables(f);
   write('Davis/Putnam (d), Recherche exhaustive (e) : '); readln(s);
   if s[1] = 'd' then begin
      write('opt (o/n) : '); readln(s); opt := s[1] = 'o';
      Davis_Putnam(f,v,opt,tauto,lref);
   end
   else begin
      exhaustive(f,v,tauto);
      lref := v;
   end;
   
   if tauto then writeln('tautologie')
   else begin
      write('rfutation: ');
      imprime_liste(lref);
   end;
end.
